import sys,os,re
import select
import win32api

#open("c:\\temp\\output.txt","w").write("'"+"\' \'".join(sys.argv)+"'\n")
#sys.stderr=open("c:\\temp\\output.txt","a")
#sys.stdout=sys.stderr

#print os.getcwd()

#print " ".join(sys.argv).replace('\t',' ')

Diffs=['ExamDiff','KDiff']
Key="diff"
Title="Select the diff program to use"

Selection=select.Select(Diffs,Title,Key)

def Rename(FileNr,Src,Dest):
  Search=re.search(r'(.*[^\s])\s+\(working copy\)',Dest)
  if Search:
    return (Search.group(1),0)
  else:
    Dest=Dest.replace('\\','_')
    Dest=Dest.replace('/','_')
    Dest=Dest.replace(':','_')
    i=FileNr
    OriDest=Dest
    while os.path.exists(Dest):
      Dest='%s_%d'%(OriDest,i)
      i+=1
    #print "Renameing '%s' to '%s'"%(Src,Dest)
    os.rename(Src,Dest)
    return (Dest,1)

#argv[3] 'tlmdm.h\t(revision 1)'
#argv[5] 'tlmdm.h\t(revision 3)'

#argv[6] 'tmp.42700.00001'
#argv[7] 'tmp.42712.00001'

File1=sys.argv[6]
File2=sys.argv[7]

#first check if the files are the same
import filecmp
if filecmp.cmp(File1,File2):
  print "files are the same"
  sys.exit(0)

Label1=re.sub(r'\t',' ',sys.argv[3])
Label2=re.sub(r'\t',' ',sys.argv[5])

(NewLabel1,Changed1)=Rename(1,File1,Label1)
(NewLabel2,Changed2)=Rename(2,File2,Label2)

if Selection=='ExamDiff':
  #print (r'C:\PROGRA~1\EXAMDI~1\ExamDiff.exe "%s" "%s"'%(NewLabel1,NewLabel2))
  ExeName=os.path.normcase(os.path.normpath(win32api.GetShortPathName(r"C:\Program Files\ExamDiff Pro\ExamDiff.exe")))
  os.system(r'%s "%s" "%s"'%(ExeName,NewLabel1,NewLabel2))
else:
  ExeName=os.path.normcase(os.path.normpath(win32api.GetShortPathName(os.path.join(os.path.split(sys.argv[0])[0],"kdiff3.exe"))))
  #print('%s "%s" "%s"'%(ExeName,NewLabel1,NewLabel2))
  os.system('%s "%s" "%s"'%(ExeName,NewLabel1,NewLabel2))

if Changed1:
  os.rename(NewLabel1,File1)
if Changed2:
  os.rename(NewLabel2,File2)
