import sys,getopt,string,os,re,shutil,tempfile,win32api
#open("c:\\temp\\output.txt","w").write(" ".join(sys.argv)+"\n")
#sys.stderr=open("c:\\temp\\output.txt","a")
#sys.stdout=sys.stderr

import select

Diffs=['KDiff3','Perforce']
Key="diff3"
Title="Select the merge tool to use"

Selection=select.Select(Diffs,Title,Key)

if Selection=='Perforce':
  import mergep4 as merge
else:
  import mergekdiff as merge

Options,Args=getopt.getopt(sys.argv[1:],"EmL:")

NewArgs=Args[:]
FileNr=0;
for (Option,Val) in Options:
  if Option=='-L':
    File=NewArgs[FileNr]
    Search=re.search(r'(.+)\.\d+\.\d+\.tmp\.\d+\.\d+\.tmp$',File)
    if Search:
      NewArgs[FileNr]=Search.group(1)+Val
    else:
      Search=re.search(r'(.+)\.\d+\.\d+\.tmp$',File)
      if Search:
        NewArgs[FileNr]=Search.group(1)+Val
      else:
        NewArgs[FileNr]=File+Val

    FileNr+=1

for i in range(len(Args)):
  #open("c:\\temp\\output.txt","a").write("Copying '%s' to '%s'\n"%(Args[i],NewArgs[i]))
  shutil.copyfile(Args[i],NewArgs[i])

TempFileName=tempfile.mktemp()

merge.ExeName=os.path.normcase(os.path.normpath(win32api.GetShortPathName(os.path.join(os.path.split(sys.argv[0])[0],merge.ExeName))))
Command=["merge","-i",NewArgs[0],"-c",NewArgs[1],"-b",NewArgs[2],"-m",TempFileName]
merge.Main(Command )

try:
  hTmp=open(TempFileName,'rb')
  import msvcrt
  msvcrt.setmode(sys.stdout.fileno(),os.O_BINARY)
  buffer=hTmp.read()
  hTmp.close()
except :
  buffer=""
if len(buffer)==0:
  # Something went wrong in the merge, keep the local file (but print a Message)
  import win32ui,win32con
  win32ui.MessageBox("Something went wrong in the merge (resulted in empty file).\nMerge not happened.\n Local file restored","Merge Errors",win32con.MB_SYSTEMMODAL)
  sys.stdout.write(open(NewArgs[0],'r').read())
else:
  sys.stdout.write(buffer)

try:
  os.remove(TempFileName)
  for i in range(len(NewArgs)):
    os.remove(NewArgs[i])
except :
  pass

